<?php


namespace Eventjuicer\Services\Commentable\Providers;

use Illuminate\Support\ServiceProvider;

class CommentableServiceProvider extends ServiceProvider
{
    /**
     * Indicates if loading of the provider is deferred.
     *
     * @var bool
     */
    protected $defer = true;

    /**
     * Register the service provider.
     *
     * @return void
     */
    public function register()
    {

        $this->app->singleton('commentable', function ($app)
        {
            return new \Services\Commentable\Commentable($app['request'], $app['config']['commentable']);
        });

    }

    /**
     * Bootstrap the application events.
     *
     * @return void
     */
    public function boot(){}

    /**
     * Get the services provided by the provider.
     *
     * @return array
     */
    public function provides()
    {
        return ['commentable'];
    }
}